(define-module (ui alternatives ajax)
    :use-module (alterator ajax)
    :use-module (alterator woo)
    :export (on-load))

;;; Functions
(define (ui-list)
  (catch/message
    (lambda()
      (let ((data (woo-list "/alternatives")))
	(form-update-enum "name" data)
	(if (pair? data)
	  (let ((name (woo-get-option (car data) 'name)))
	    (form-update-value "name" name)
	    (ui-read name)))))))

(define (ui-manual . manual)
  (let ((manual (if (pair? manual) (car manual) (form-value "manual"))))
    (form-update-activity "current" manual)))

(define (ui-read . name)
  (let ((name (if (pair? name) (car name) (form-value "name"))))
    (catch/message
      (lambda()
	(let ((data (woo-read-first "/alternatives" 'name name)))
	  (form-update-enum "current" (woo-list "/alternatives/avail_candidate" 'name name))
	  (form-update-value-list '("current" "manual") data)
	  (ui-manual (woo-get-option data 'manual)))))))

(define (ui-write)
  (catch/message
    (lambda()
      (apply woo-write
	     "/alternatives"
	     (form-value-list '("name" "current" "manual")))
      (ui-read (form-value "name")))))

(define (on-load)
  (ui-list)
  (form-bind "name" "change" ui-read)
  (form-bind "manual" "change" ui-manual)
  (form-bind "apply" "click" ui-write))
